﻿Public Class KostkaNaPatre
	Public barva As Color
	Public rozmer As Size
	Public pocet As Integer
	Public patro As Integer
	Public pozice As Point

	Public Sub New(filString As String)
		Dim parts = filString.Split(New Char() {" "}, StringSplitOptions.RemoveEmptyEntries)
		patro = parts(0)

		Dim x = parts(1)
		Dim y = parts(2)

		pozice = New Point(x, y)

		barva = ParsujBarvu(parts(3))

		rozmer = ParsujVeliost(parts(4))
	End Sub

	''' <summary>
	''' Zpracuje barvu (CHar > Color)
	''' </summary>
	Public Shared Function ParsujBarvu(barva As Char) As Color
		barva = barva.ToString().ToUpper()
		Select Case barva
			Case "A"
				Return Color.Azure
			Case "R"
				Return Color.Red
			Case "G"
				Return Color.Green
			Case "B"
				Return Color.Blue
			Case Else
				Return Color.Yellow
		End Select
	End Function

	''' <summary>
	''' Zpracuje velikost (String > Size)
	''' </summary>
	Public Shared Function ParsujVeliost(velikost As String) As Size
		Dim parts = velikost.ToUpper().Split("X")
		Return New Size(parts(0), parts(1))
	End Function

	''' <summary>
	''' Zjistí zdali se kostka nachází na určité lince Y
	''' </summary>
	Public Function JsiNaLinceY(linka As Integer) As Boolean
		Dim poziceYnahore As Integer = Me.pozice.Y
		Dim poziceYdole As Integer = Me.pozice.Y + Me.rozmer.Height - 2
		Dim vysledek = (poziceYnahore >= linka And poziceYdole <= linka)
		Return vysledek
	End Function

	''' <summary>
	''' Zjistí zdali se kostka nachází na určité lince X
	''' </summary>
	Public Function JsiNaLinceX(linka As Integer) As Boolean
		Dim poziceXnahore As Integer = Me.pozice.X
		Dim poziceXdole As Integer = Me.pozice.X + Me.rozmer.Width - 2
		Dim vylsedek = (poziceXnahore >= linka And poziceXdole <= linka)
		Return vylsedek
	End Function

	'Public Function JeNaStrane1(vyska As Integer) As Boolean
	'	return Me.pozice.Y + Me.rozmer.Height = vyska
	'End Function
End Class
