﻿Imports System.IO

Public Class Specifikace
	' Zadani
	Public x As Integer
	Public y As Integer

	Public typ As Typy
	Public sousedniKostkyNesmiBytStejne As Boolean

	Public kostky As New List(Of Kostka)
	' Vysledek
	Private output As StreamWriter
	Private pocetUloznechyPater = 1

	Public Sub New(fileName As String)
		Dim output As String = fileName.Substring(0, fileName.Length - 3)
		output &= "." & Soutez.StartovniCislo
		CreateOutput(output)

		Using ctecka As New IO.StreamReader(fileName)
			ParseFirstLine(ctecka.ReadLine().ToUpper())

			While Not ctecka.EndOfStream
				kostky.Add(New Kostka(ctecka.ReadLine()))
			End While

			Postav()
		End Using
	End Sub

	Public Sub ParseFirstLine(fl As String)
		Dim partsOFFirstLine = fl.Split(New Char() {" "}, StringSplitOptions.RemoveEmptyEntries)
		x = partsOFFirstLine(0)
		y = partsOFFirstLine(1)

		If partsOFFirstLine(2)(0) = "P" Then
			typ = Typy.P
		Else
			typ = Typy.D
		End If

		' pokud ma B
		sousedniKostkyNesmiBytStejne = partsOFFirstLine(2).Length > 1
	End Sub

	Public Sub CreateOutput(fileName As String)
		output = New IO.StreamWriter(fileName)
	End Sub

	Public Sub Postav()
		While PocetKostek() - PocetKosticekNaPosledniPatro() >= 0
			Try
				Dim p = PostavPatro()
				UlozPatro(p)
			Catch ex As Exception
				Exit While
			End Try
		End While
	End Sub

	Public Function PostavPatro() As Patro
		Dim p As New Patro(New Size(x, y))
		Dim serazeneKostkyPodleVelikosti = (From k In kostky Order By k.Obsah())

		Dim pp = p.plocha
		' okraj Horni

		Dim pocetZbyvajiciDelky As Integer = Me.x
		While pocetZbyvajiciDelky >= 0
			serazeneKostkyPodleVelikosti = (From k In kostky
											Where k.rozmer.Width < pocetZbyvajiciDelky
											Order By k.Obsah())

			Dim kostka As Kostka
			Dim iKostky = 0
			kostka = serazeneKostkyPodleVelikosti(iKostky)
			While kostka.rozmer.Width > pocetZbyvajiciDelky And kostka.pocet = 0
				iKostky += 1
				kostka = serazeneKostkyPodleVelikosti(iKostky)
			End While

			kostka.PridejDoPole(pp, New Point(0, Me.x - pocetZbyvajiciDelky))
		End While
		Return p
	End Function

	Public Function PocetPotrebnychKosticekNaPatro() As Integer
		Dim okraj = Me.x * 2 + Me.y * 2 - 4
		If Me.typ = Typy.D Then
			Return okraj
		Else
			Return PocetKosticekNaPosledniPatro()
		End If
	End Function

	Public Function PocetKosticekNaPosledniPatro() As Integer
		Return Me.x * Me.y
	End Function

	Public Function PocetKostek() As Integer
		Dim suma = 0
		For Each k In kostky
			suma += k.pocet
		Next
		Return suma
	End Function

	Public Sub UlozPatro(patro As Patro)
		Dim vylsekde = ""
		Dim kostickyPatra As New List(Of Kostka)

		For _x = 0 To patro.plocha.Count - 1
			For _y = 0 To patro.plocha.Count - 1
				If Not kostickyPatra.Contains(patro.plocha(_x)(_y)) Then
					Dim kostkaString = pocetUloznechyPater & " " & _x & " " & _y & " " & barvaNaString(patro.plocha(_x)(_y).barva) & rozmeryNaString(patro.plocha(_x)(_y).rozmer)
					vylsekde &= kostkaString & vbCrLf
				End If
			Next
		Next

		output.Write(vylsekde)
	End Sub

	Public Function barvaNaString(barva As Barvy) As String
		Select Case barva
			Case Barvy.A
				Return "A"
			Case Barvy.R
				Return "R"
			Case Barvy.G
				Return "G"
			Case Barvy.B
				Return "B"
			Case Else
				Return "Y"
		End Select
	End Function

	Public Function rozmeryNaString(rozmery As Size) As String
		Return rozmery.Width & "X" & rozmery.Height
	End Function
End Class

Public Enum Typy
	P
	D
End Enum