﻿Public Class Ukazovac
	Private g As Graphics

	' Vez
	Dim velikost As Size
	Dim kostky As New List(Of KostkaNaPatre)

	Private kdeJsme As Integer = 0

	Private pocetPater As Integer


	''' <summary>
	''' Umožní vybrat cestu v dialogovém oknu
	''' </summary>
	Private Sub btnSelectPath_Click(sender As Object, e As EventArgs) Handles btnSelectPath.Click
		Dim od As New OpenFileDialog()
		If od.ShowDialog() = Windows.Forms.DialogResult.OK Then
			txtPath.Text = od.FileName
		End If
	End Sub


	''' <summary>
	''' Připraví plátno
	''' </summary>
	Private Sub Ukazovac_Load(sender As Object, e As EventArgs) Handles MyBase.Load
		Me.g = pcbThumbnail.CreateGraphics()
	End Sub


	''' <summary>
	''' Překreslí pohledem z vrchu
	''' </summary>
	Public Sub RepaintViewFromTop()
		g.Clear(Color.White)
		Dim patro = NumericUpDown1.Value
		Dim kostkyNaPatre = (From k In kostky Where CInt(k.patro) = CInt(patro))
		Dim c = kostkyNaPatre.Count()
		For Each k In kostkyNaPatre
			Dim r = New Rectangle((k.pozice.X - 1) * 10, (k.pozice.Y - 1) * 10, k.rozmer.Width * 10, k.rozmer.Height * 10)
			g.FillRectangle(New SolidBrush(k.barva), r)
			g.DrawRectangle(Pens.Black, r)
		Next
	End Sub


	''' <summary>
	''' Překreslí pohledem z boku
	''' </summary>
	Public Sub RepaintViewFromSide()
		g.Clear(Color.White)
		Dim strana As Integer = kdeJsme
		Dim q = (From k In kostky Where k.JsiNaLinceY(velikost.Height))
		Dim sirka As String
		Select Case strana
			Case 0
				q = (From k In kostky Where k.JsiNaLinceY(velikost.Height))
				sirka = "W"
			Case 1
				q = (From k In kostky Where k.JsiNaLinceX(0))
				sirka = "H"
			Case 0
				q = (From k In kostky Where k.JsiNaLinceY(0))
				sirka = "W"
			Case Else
				q = (From k In kostky Where k.JsiNaLinceX(velikost.Width))
				sirka = "H"
		End Select

		Dim c = q.Count()

		For Each k As KostkaNaPatre In q
			Dim r As Rectangle
			If sirka = "W" Then
				r = New Rectangle(k.pozice.X * 10, (pocetPater - k.patro) * 10, k.rozmer.Width * 10, 10)



			Else
				r = New Rectangle(k.pozice.X * 10, (pocetPater - k.patro) * 10, k.rozmer.Height * 10, 10)
			End If

			g.FillRectangle(New SolidBrush(k.barva), r)
			g.DrawRectangle(Pens.Black, r)
		Next
	End Sub

	Public Enum Hrany
		Nahore
		Vpravo
		Dole
		Vlevo
	End Enum


	''' <summary>
	''' Načte soubor
	''' </summary>
	Private Sub btnLoad_Click(sender As Object, e As EventArgs) Handles btnLoad.Click
		pocetPater = 0
		kostky.Clear()

		Using ctecka As New IO.StreamReader(txtPath.Text)
			ParseFirstLine(ctecka.ReadLine())
			While Not ctecka.EndOfStream
				Dim line = ctecka.ReadLine()
				If line = "" Then
					Continue While
				End If
				Dim k As New KostkaNaPatre(line)
				kostky.Add(k)
			End While
			pocetPater = (From k In kostky Order By k.patro Descending).First().patro
			ToolStripStatusLabel1.Text = "Velikost věže: " & velikost.Width & "×" & velikost.Height & "×" & pocetPater
			createSummary()
			NumericUpDown1.Maximum = pocetPater
			Repaint()
		End Using
	End Sub


	''' <summary>
	''' Vytvoří výpis počtu kostek
	''' </summary>
	Public Sub createSummary()
		Dim a = (From k In kostky Where k.barva = Color.Azure).Count()
		Dim r = (From k In kostky Where k.barva = Color.Red).Count()
		Dim g = (From k In kostky Where k.barva = Color.Green).Count()
		Dim b = (From k In kostky Where k.barva = Color.Blue).Count()
		Dim y = (From k In kostky Where k.barva = Color.Yellow).Count()

		Dim summary =
			"A:" & a & vbCrLf &
			"R:" & r & vbCrLf &
			"G:" & g & vbCrLf &
			"B:" & b & vbCrLf &
			"Y:" & y

		lblSummary.Text = summary
	End Sub


	''' <summary>
	''' Parsruje první řádek souboru
	''' </summary>
	Public Sub ParseFirstLine(fl As String)
		Dim partsOFFirstLine = fl.Split(New Char() {" "}, StringSplitOptions.RemoveEmptyEntries)
		Dim x = partsOFFirstLine(0)
		Dim y = partsOFFirstLine(1)

		Me.velikost = New Size(x, y)
	End Sub

	'Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs)
	'	'NumericUpDown1.Minimum = 1
	'	'If ComboBox1.SelectedIndex = 0 Then
	'	'	NumericUpDown1.Maximum = pocetPater
	'	'	lblNumLabel.Text = "Patro"
	'	'Else
	'	'	NumericUpDown1.Maximum = 4
	'	'	lblNumLabel.Text = "Strana"
	'	'End If
	'	Repaint()
	'End Sub


	''' <summary>
	''' Při kliknutí překreslí
	''' </summary>
	Private Sub pcbThumbnail_Click(sender As Object, e As EventArgs) Handles pcbThumbnail.Click
		Repaint()
	End Sub


	''' <summary>
	''' Překreslí defaultním způsobem
	''' </summary>
	Private Sub Repaint()
		'Select Case ComboBox1.SelectedIndex
		'	Case 0
		'		RepaintViewFromTop()
		'	Case 1
		'		RepaintViewFromSide()
		'End Select
		Try
			RepaintViewFromTop()

		Catch ex As Exception

		End Try
	End Sub


	''' <summary>
	''' Při změně hodnoty překrelsí
	''' </summary>
	Private Sub NumericUpDown1_ValueChanged(sender As Object, e As EventArgs) Handles NumericUpDown1.ValueChanged
		Repaint()
	End Sub


	''' <summary>
	''' Při kliknutí na tlačítko Stěna/otoč otočí apřekreslí v pohledu ze strany
	''' </summary>
	Private Sub bthSide_Click(sender As Object, e As EventArgs) Handles bthSide.Click
		kdeJsme += 1
		If kdeJsme = 3 Then
			kdeJsme = 0
		End If
		RepaintViewFromSide()
	End Sub

	''' <summary>
	''' překreslí ze zhora
	''' </summary>
	Private Sub btnTop_Click(sender As Object, e As EventArgs) Handles btnTop.Click
		RepaintViewFromTop()
	End Sub
End Class